// Autogenerated from Pigeon (v12.0.1), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name, unnecessary_import

import 'dart:async';
import 'dart:typed_data' show Float64List, Int32List, Int64List, Uint8List;

import 'package:flutter/foundation.dart' show ReadBuffer, WriteBuffer;
import 'package:flutter/services.dart';
List<Object?> wrapResponse({Object? result, PlatformException? error, bool empty = false}) {
  if (empty) {
    return <Object?>[];
  }
  if (error == null) {
    return <Object?>[result];
  }
  return <Object?>[error.code, error.message, error.details];
}

class OAuthUserConfigurations {
  OAuthUserConfigurations({
    required this.portalUrl,
    required this.clientId,
    required this.redirectUrl,
  });

  String portalUrl;

  String clientId;

  String redirectUrl;

  Object encode() {
    return <Object?>[
      portalUrl,
      clientId,
      redirectUrl,
    ];
  }

  static OAuthUserConfigurations decode(Object result) {
    result as List<Object?>;
    return OAuthUserConfigurations(
      portalUrl: result[0]! as String,
      clientId: result[1]! as String,
      redirectUrl: result[2]! as String,
    );
  }
}

abstract class AGMLAuthApiHandler {
  static const MessageCodec<Object?> codec = StandardMessageCodec();

  void oAuthUserState(bool state);

  static void setup(AGMLAuthApiHandler? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.AuthPigeon.AGMLAuthApiHandler.oAuthUserState', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
          'Argument for dev.flutter.pigeon.AuthPigeon.AGMLAuthApiHandler.oAuthUserState was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final bool? arg_state = (args[0] as bool?);
          assert(arg_state != null,
              'Argument for dev.flutter.pigeon.AuthPigeon.AGMLAuthApiHandler.oAuthUserState was null, expected non-null bool.');
          try {
            api.oAuthUserState(arg_state!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          }          catch (e) {
            return wrapResponse(error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}

class _AGMLAuthApiCodec extends StandardMessageCodec {
  const _AGMLAuthApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is OAuthUserConfigurations) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128: 
        return OAuthUserConfigurations.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class AGMLAuthApi {
  /// Constructor for [AGMLAuthApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  AGMLAuthApi({BinaryMessenger? binaryMessenger})
      : _binaryMessenger = binaryMessenger;
  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _AGMLAuthApiCodec();

  Future<void> oAuthUser(OAuthUserConfigurations arg_portalConfig, String arg_username, String arg_password) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AuthPigeon.AGMLAuthApi.oAuthUser', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_portalConfig, arg_username, arg_password]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> setApiKey(String arg_apiKey) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AuthPigeon.AGMLAuthApi.setApiKey', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_apiKey]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else {
      return;
    }
  }
}
